--Carrier Script v.1.0 by Wrench

--[[ MINIMUM ME SETUP:
	MISSION START		-					DOSCRIPTFILE MIST
											DOSCRIPTFILE Carrier Script
											Wrench.wind_setup('unit1', distip, cycletime, {tankers})
	
	CARRIER "TRIGGERED ACTIONS" Must have as index 1, "ACTIVATE TACAN"
********NOTES********
Even if the wind is over 25 knots, the carrier will always travel at least 5 knots, or else it will endlessly travel in circles.
	You might have luck getting it a bit lower, but will require some testing.
	
The arguments for Wrench.wind_setup are as follows:
	The name of the carrier unit (must have quotes i.e. '' or "")
	The maximum distance the carrier will travel before returning to it's IP from the ME.
		Note that the father you set this, the longer it will take for the carrier to turn around, but the longer it will be before you get	
		ideal wind conditions again. If using cycle time, set this to any number. i.e. 1.

	The cycle time (optional) this will override the distip in favor of a cycle time. This is the time from recovery to recovery, in other 
		words ,including the return trip (estimated) if not used, set to nil (no quotes)
	The tanker table of Unit names you'd like to orbit the carrier, and follow it on it's route. This allows a tanker to follow the carrier's
		path, without getting left behind as it moves. Note that if the tanker spawns on the carrier deck in the mission editor, 
		it will continue to do so every time is is spawned.


		
Note that if you want to use distip and the tanker, the script would read something like
	Wrench.wind_setup('carrier', 87000, nil, {'tanker1'})
		
I haven't finished bullet-proofing this yet, so You'll get error messages if you make a mistake editing the mission, or creating your own.
Thanks to many members of the community (largely Grimes) for helping my stumble my way through the code.
Thanks again to Grimes, and to Speed for MiST, which is used in many parts of this script.

For reference, the call in the release mission is something like 
	Wrench.wind_setup('stns', 1, 60, {'tanker1', 'tanker2'})
]]
if not Wrench then
	Wrench = {}
end
Wrench.Carrier = {}
Wrench.Carrier.Tankerdist = 3*1852
Wrench.Carrier.Tankmarks = true
local myLog = mist.Logger:new('Carrier Script')
myLog:msg('Carrier Script by Wrench loaded')
CarScript = missionCommands.addSubMenu('Carrier Script' ,nil)
Wrench.Carrier.marknumbers = {}
function Wrench.ship_from_ip(unit1, distip)
	if mist.utils.get2DDist(Wrench.Carrier[unit1..'position'] ,Wrench.Carrier[unit1 .. 'startpos']) > distip then
		Wrench.carrier_to_ip(unit1)
	end
end
function Wrench.shipshore(unit1)
	local aheaddir = mist.getHeading(Wrench.Carrier[unit1] , false )
	local lookaheadpos = {x = ((math.cos(aheaddir) * 18520) + Wrench.Carrier[unit1..'position'].x), z = ((math.sin(aheaddir) * 18520) + Wrench.Carrier[unit1..'position'].z), y = Wrench.Carrier[unit1..'position'].y}
	local surf_type = land.getSurfaceType(mist.utils.makeVec2(lookaheadpos))
	if surf_type == 3 then else
		myLog:msg('ship too close to shore')
		Wrench.carrier_to_ip(unit1)
	end
end
function Wrench.carrier_to_ip(unit1)
	Wrench.Carrier[unit1 .. 'returning'] = true
	Wrench.Carrier[unit1 .. 'ET'] = 0
	local group1 = Unit.getGroup((Wrench.Carrier[unit1]))
	local retdir = mist.utils.getDir(Wrench.Carrier[unit1..'position'] , Wrench.Carrier[unit1 .. 'startpos'])
	local new = {}
		local new = {x = ((math.cos(retdir+0.785398) * 1500) + Wrench.Carrier[unit1..'position'].x), z = ((math.sin(retdir+0.785398) * 1500) + Wrench.Carrier[unit1..'position'].z), y = 0}
	local path = {} 
	path[#path + 1] = mist.ground.buildWP(Wrench.Carrier[unit1..'position'], 'Diamond', 5.14444)
	path[#path + 1] = mist.ground.buildWP(new, 'Diamond', 5.14444)
	path[#path + 1] = mist.ground.buildWP(Wrench.Carrier[unit1 .. 'startpos'], 'Diamond', 30.3522)
	mist.goRoute(group1 ,path)
end
function Wrench.get_wind(unit1, distip)
if Wrench.Carrier[unit1 .. 'stop'] then 
	trigger.action.groupStopMoving(Wrench.Carrier[unit1 .. 'group'])
else
if	trigger.misc.getUserFlag(Wrench.Carrier[unit1]["id_"]+0.1) == 1 then
		Wrench.Carrier[unit1 .. 'returning'] = false
	end
if not Wrench.Carrier[unit1 .. 'returning'] then
	local wind = {}
	local windspeed = {}
	if Wrench.Carrier[unit1] then
		Wrench.Carrier[unit1..'position'] = Wrench.Carrier[unit1]:getPosition().p
		Wrench.Carrier[unit1..'magvarrad'] = mist.getNorthCorrection(Wrench.Carrier[unit1..'position'])
		Wrench.Carrier[unit1..'magvar'] = mist.utils.toDegree(Wrench.Carrier[unit1..'magvarrad'])
		if Wrench.Carrier[unit1..'position'] ~= nil then
			Wrench.Carrier[unit1..'position'].y=Wrench.Carrier[unit1..'position'].y+1
			--get wind info
			wind = atmosphere.getWind(Wrench.Carrier[unit1..'position'])
			windspeed = mist.vec.mag(wind)
			--get wind direction sorted
			local dir = math.atan2(wind.z, wind.x) * 180 / math.pi
			if dir < 0 then
				dir = dir + 360 --converts to positive numbers		
			end
			if dir <= 180 then
				dir = dir + 180
			else
				dir = dir - 180
			end
			dir = dir + Wrench.Carrier[unit1 .. 'offset'] --to account for angle of landing deck and movement of the ship
			if dir > 360 then
				dir = dir - 360
			end
			Wrench.Carrier[unit1..'dir'] = math.floor(dir+Wrench.Carrier[unit1..'magvar'])
			Wrench.Carrier[unit1..'heading'] = math.floor(mist.utils.toDegree(mist.getHeading(Wrench.Carrier[unit1] , false )))
			local dirrad = mist.utils.toRadian(dir)
			if windspeed < 12.8611 then
				speed = 12.8611 - windspeed
				Wrench.go_direction(unit1,dirrad,speed)
			else
				Wrench.go_direction(unit1,dirrad,1)
			end
				if not Wrench.Carrier[unit1 .. 'override'] then
					if Wrench.Carrier[unit1 .. 'LARC'] then
						Wrench.LARC(unit1)
						Wrench.shipshore(unit1)
					else
						Wrench.ship_from_ip(unit1, distip)
						Wrench.shipshore(unit1)
					end
				end
			end
	else
		trigger.action.outText('unit not detected', 2)
	end
else
	if Wrench.Carrier[unit1 .. 'LARC'] then
		Wrench.LARC(unit1)
	end
end
end
end
function Wrench.CarrierSpeed(unit1,dir,speed)
	local headingrad = mist.getHeading(Wrench.Carrier[unit1] , false )
	dir = dir+Wrench.Carrier[unit1..'magvarrad']
	if (headingrad < dir+0.0872665) and (headingrad > dir-0.0872665) then
		return speed
	else 
		return 5.14444
	end
end
function Wrench.LARC(unit1)
	Wrench.Carrier[unit1 .. 'ET'] = Wrench.Carrier[unit1 .. 'ET'] + 10
	Wrench.Carrier[unit1 .. 'Traveled'] = mist.utils.get3DDist(Wrench.Carrier[unit1..'position'] ,Wrench.Carrier[unit1 .. 'startpos'])
	Wrench.Carrier[unit1 .. 'estimated retun time'] = (Wrench.Carrier[unit1 .. 'Traveled']/12.8611)+240
	if Wrench.Carrier[unit1 .. 'ET'] + Wrench.Carrier[unit1 .. 'estimated retun time'] >= Wrench.Carrier[unit1 .. 'LARC'] then
		Wrench.carrier_to_ip(unit1)
	end
end
function Wrench.go_direction(unit1,dir,speed)
	if Wrench.Carrier[unit1..'position'] ~= nil then
		local group1 = Unit.getGroup((Wrench.Carrier[unit1]))
		local new = {}
		local new = {x = ((math.cos(dir) * 1000) + Wrench.Carrier[unit1..'position'].x), z = ((math.sin(dir) * 1000) + Wrench.Carrier[unit1..'position'].z), y = 0}
		local path = {} 
			path[#path + 1] = mist.ground.buildWP(Wrench.Carrier[unit1..'position'], 'Diamond', Wrench.CarrierSpeed(unit1,dir,speed))
			path[#path + 1] = mist.ground.buildWP(new, 'Diamond', Wrench.CarrierSpeed(unit1,dir,speed))
		mist.goRoute(group1 ,path)
	end
end
function Wrench.carrier_at_ip(unit1)
	local unittable = mist.makeUnitTable({unit1})
	local ipzone = {}
	ipzone[1] = {x = ((math.cos(0) * 500) + Wrench.Carrier[unit1 .. 'startpos'].x), z = ((math.sin(0) * 500) + Wrench.Carrier[unit1 .. 'startpos'].z), y = 0}
	ipzone[2] = {x = ((math.cos(1.5708) * 500) + Wrench.Carrier[unit1 .. 'startpos'].x), z = ((math.sin(1.5708) * 500) + Wrench.Carrier[unit1 .. 'startpos'].z), y = 0}
	ipzone[3] = {x = ((math.cos(3.14159) * 500) + Wrench.Carrier[unit1 .. 'startpos'].x), z = ((math.sin(3.14159) * 500) + Wrench.Carrier[unit1 .. 'startpos'].z), y = 0}
	ipzone[4] = {x = ((math.cos(4.71239) * 500) + Wrench.Carrier[unit1 .. 'startpos'].x), z = ((math.sin(4.71239) * 500) + Wrench.Carrier[unit1 .. 'startpos'].z), y = 0}
	local vars = 
		{
		units = unittable, 
		zone = ipzone, 
		flag = Wrench.Carrier[unit1]["id_"]+0.1,
		stopFlag = nil, 
		maxalt = 200, 
		req_num = 1, 
		interval = 1, 
		toggle = true,
		}
	mist.flagFunc.units_in_polygon(vars)
end
function Wrench.querymode(unit1,grp)
	if Wrench.Carrier[unit1 .. 'returning'] then 
		trigger.action.outText(unit1 .. ' is returning.', 2)
		if Wrench.Carrier[unit1 .. 'estimated return time'] then
			trigger.action.outTextForGroup(grp,unit1 .. ' is returning, CHARLIE in ' .. tostring(math.floor(Wrench.Carrier[unit1 .. 'estimated retun time']/60)-2) .. ' minutes.', 2)
		end
	end
	if Wrench.Carrier[unit1 .. 'override'] then
		trigger.action.outTextForGroup(grp,unit1 .. ' is in manual override mode.', 2)
	end
	if (not Wrench.Carrier[unit1 .. 'override']) and (not Wrench.Carrier[unit1 .. 'returning']) then
		if Wrench.Carrier[unit1..'heading'] >= Wrench.Carrier[unit1..'dir']-5 and Wrench.Carrier[unit1..'heading'] <= Wrench.Carrier[unit1..'dir']+5 then
			local charlietime = math.floor(((Wrench.Carrier[unit1 .. 'LARC']/2)/60)-(Wrench.Carrier[unit1 .. 'ET']/60))
			trigger.action.outTextForGroup(grp,unit1 .. ' is ready for recovery. CHARLIE TIME '..charlietime..' minutes.', 2)
		else
			trigger.action.outTextForGroup(grp,unit1 .. ' is turning to '..Wrench.Carrier[unit1..'dir']..'.', 2)
		end
	end
	if Wrench.Carrier[unit1 .. 'stop'] then
		trigger.action.outTextForGroup(grp,unit1 .. ' is stopped.', 2)
	end
end
function Wrench.get_carpos_BR(unit1,grp)
	local leadpos = mist.getLeadPos(grp)
	local vars = 
	{	
		units = {unit1} , 
		ref = leadpos, 
		alt = false,
		metric = false,
	}
	local bulls = coalition.getMainRefPoint(Unit.getByName(unit1):getCoalition())
	
	--mist.vec.sub(Wrench.Carrier[unit1..'position'],bulls)
	local bearing = math.floor(mist.utils.toDegree(mist.utils.getDir(mist.vec.sub(Wrench.Carrier[unit1..'position'],bulls)))+Wrench.Carrier[unit1..'magvar'])
	local dist = math.floor(mist.utils.metersToNM(mist.utils.get2DDist(bulls ,Wrench.Carrier[unit1..'position'])))
	
	local RawNorthing = (coord.LOtoLL(Wrench.Carrier[unit1..'position']))
	local RawEasting = (select(2,coord.LOtoLL(Wrench.Carrier[unit1..'position'])))
	local DegreesNorthing = math.floor(RawNorthing)
	local DegreesEasting = math.floor(RawEasting)
	local MinutesNorthing = (RawNorthing - DegreesNorthing)*60
	local MinutesEasting = (RawEasting - DegreesEasting)*60
	local SecondsNorthing = mist.utils.round((MinutesNorthing-math.floor(MinutesNorthing))*60)
	local SecondsEasting = mist.utils.round((MinutesEasting-math.floor(MinutesEasting))*60)
	local EastingDir = 'E'
	
	if MinutesEasting < 0 then
		MinutesEasting = math.abs(MinutesEasting)
		Eastingdir = 'W'
	else
		Eastingdir = 'E'
	end
	local text = unit1..' is at '..mist.getBRString(vars)..'\n'..'BULLS ' .. bearing .. ' for ' .. dist
	text = text .. '\n' .. 'Coordinates:\n' .. 
		string.format("%02d",DegreesNorthing) .. '° ' ..
		string.format("%02d",math.floor(MinutesNorthing)) .. '"' ..
		string.format("%02d",SecondsNorthing) .. "' N\n" .. 
		string.format("%02d",DegreesEasting) .. '° ' .. 
		string.format("%02d",math.floor(MinutesEasting)) .. '"' ..
		string.format("%02d",SecondsEasting) .. "' "..Eastingdir
	trigger.action.outTextForGroup(Group.getByName(grp):getID(), text, 30 , false)
end
function Wrench.orbit_carrier(carrier,tanker,dir)
	if Wrench.Carrier.Tankmarks then
		for i=1, #Wrench.Carrier.marknumbers do
			trigger.action.removeMark(i)
		end
	end
	Wrench.Carrier[tanker] = Unit.getByName(tanker)
	local durrad = mist.utils.toRadian(dir+7)
	local carpos = Unit.getByName(carrier):getPosition().p
	local airpos = Unit.getByName(tanker):getPosition().p	
	local group1 = Unit.getGroup(Wrench.Carrier[tanker])
	local track = {}
	local path = {}
	track[1] = {x = airpos.x, z = airpos.z, y = airpos.y}
	track[2] = {x = ((math.cos(durrad) * Wrench.Carrier.Tankerdist/2) + carpos.x), z = ((math.sin(durrad) * Wrench.Carrier.Tankerdist/2) + carpos.z), y = 1828.8}
	track[3] = {x = ((math.cos(durrad - 1.5708) * Wrench.Carrier.Tankerdist) + track[2].x), z = ((math.sin(durrad - 1.5708) * Wrench.Carrier.Tankerdist) + track[2].z), y = 1828.8}
	track[4] = {x = ((math.cos(durrad - 3.14159) * Wrench.Carrier.Tankerdist) + track[3].x), z = ((math.sin(durrad - 3.14159) * Wrench.Carrier.Tankerdist) + track[3].z), y = 1828.8}
	track[5] = {x = ((math.cos(durrad - 4.71239) * Wrench.Carrier.Tankerdist) + track[4].x), z = ((math.sin(durrad - 4.71239) * Wrench.Carrier.Tankerdist) + track[4].z), y = 1828.8}
	
	if Wrench.Carrier.Tankmarks then
		for i=1, #track do
			Wrench.Carrier.marknumbers[#Wrench.Carrier.marknumbers+1] = track[i]
		end
		for i=1, #Wrench.Carrier.marknumbers do
			trigger.action.markToAll(i, tostring(i), Wrench.Carrier.marknumbers[i] , false, nil)
		end
	end
	
	for i = 1, #track do
		path[i] = mist.fixedWing.buildWP(track[i], 'turningpoint' ,169.767 ,1828.8 ,'Baro' )
	end
	local funcstring = 'Wrench.orbit_carrier'.."(".."'"..carrier.."'"..",".."'"..tanker.."'"..","..dir..")"
	path[1]= -- needed to keep tanker tanking
	{
		--retain original keys&values
		["alt"] = path[1]["alt"], 
		["x"] = path[1]["x"], 
		["action"] = path[1]["action"], 
		["alt_type"] = path[1]["alt_type"], 
		["speed"] = path[1]["speed"], 
		["type"] = path[1]["type"], 
		["y"] = path[1]["y"],
		--add tasking		
		["task"] = 
		{
			["id"] = "ComboTask",
			["params"] = 
			{
				["tasks"] = 
				{
					[1] = 
					{
						["enabled"] = true,
						["auto"] = true,
						["id"] = "Tanker",
						["number"] = 1,
						["params"] = 
						{
						},
					},
				},
			},
		},
	}	
	path[5]=
	{
		--retain original keys&values
		["alt"] = path[5]["alt"], 
		["x"] = path[5]["x"], 
		["action"] = path[5]["action"], 
		["alt_type"] = path[5]["alt_type"], 
		["speed"] = path[5]["speed"], 
		["type"] = path[5]["type"], 
		["y"] = path[5]["y"],
		--add tasking		
		["task"] = 
		{
			["id"] = "ComboTask",
			["params"] = 
			{
				["tasks"] = 
				{
					[1] = 
					{
						["enabled"] = true,
						["auto"] = false,
						["id"] = "WrappedAction",
						["number"] = 1,
						["params"] = 
						{
							["action"] = 
							{
								["id"] = "Script",
								["params"] = 
								{
									["command"] = funcstring,
								}, -- end of ["params"]
							}, -- end of ["action"]
						}, -- end of ["params"]
					}, -- end of [1]
				}, -- end of ["tasks"]
			}, -- end of ["params"]
		}, -- end of ["task"]
	}
	local tankerfuel = Unit.getFuel(Wrench.Carrier[tanker])
	if tankerfuel < .15 then
		path = {}
		track = {}
		path[1] = {x = carpos.x, z = carpos.z, y = 0}
		path[1] = mist.fixedWing.buildWP(path[1], 'turningpoint' ,180.056 ,6096 ,'Baro' )
		path[1]=
		{
		--retain original keys&values
			["alt"] = 100, 
			["x"] = path[1]["x"], 
			["action"] = "Landing",
			["alt_type"] = path[1]["alt_type"], 
			["speed"] = path[1]["speed"], 
			["type"] = path[1]["type"], 
			["y"] = path[1]["y"],
		}
	end
	mist.goRoute(group1 ,path)
end
function Wrench.get_carrier_type(unit1)
	unit1desc = Unit.getDesc(unit1)["typeName"]
	myLog:msg(unit1desc)
	if unit1desc == "Stennis" or unit1desc == "KUZNECOW" then
		return 8
	else
		return 0
	end
end
function Wrench.wind_setup(unit1, distip, LARC, tanker)
	myLog:msg('Carrier Script by Wrench Called for '..unit1)
	Wrench.Carrier[unit1] = Unit.getByName(unit1)
	Wrench.Carrier[unit1 .. 'name'] = unit1
	trigger.action.setUserFlag(Wrench.Carrier[unit1]["id_"]+0.1, 1)
	--VARS
	Wrench.Carrier[unit1 .. 'startpos'] = Wrench.Carrier[unit1]:getPosition().p
	Wrench.Carrier[unit1 .. 'returning'] = false
	Wrench.Carrier[unit1 .. 'override'] = false	
	Wrench.Carrier[unit1 .. 'stop'] = false
	Wrench.Carrier[unit1 .. 'coa'] = Unit.getCoalition(Wrench.Carrier[unit1])
	Wrench.Carrier[unit1 .. 'group'] = Unit.getGroup(Wrench.Carrier[unit1])--:getName()
	Wrench.Carrier[unit1 .. 'tacan'] = {}
	Wrench.Carrier[unit1 .. 'ICLS'] = {}
	Wrench.Carrier[unit1 .. 'offset'] = Wrench.get_carrier_type(Wrench.Carrier[unit1])
	myLog:msg(Wrench.Carrier[unit1 .. 'name'] .. ' Offset is '..Wrench.Carrier[unit1 .. 'offset'])
	---------get TACAN--------
	local route = mist.getGroupRoute(Wrench.Carrier[unit1 .. 'group']:getName() , true)
		local tasks = route[1]["task"]["params"]["tasks"]
		for i=1,#tasks do
			if tasks[i]["params"]["action"]["id"] == "ActivateBeacon" then
				Wrench.Carrier[unit1 .. 'tacan']["callsign"] = tasks[i]["params"]["action"]["params"]["callsign"]
				Wrench.Carrier[unit1 .. 'tacan']["modeChannel"] = tasks[i]["params"]["action"]["params"]["modeChannel"]
				Wrench.Carrier[unit1 .. 'tacan']["channel"] = tasks[i]["params"]["action"]["params"]["channel"]
			elseif tasks[i]["params"]["action"]["id"] == "ActivateICLS" then
				Wrench.Carrier[unit1 .. 'ICLS']["channel"] = tasks[i]["params"]["action"]["params"]["channel"]
			end
		end
	if LARC then
		Wrench.Carrier[unit1 .. 'LARC'] = LARC*60
	end
	Wrench.Carrier[unit1 .. 'ET'] = 0
	--MENU
	Wrench.Carrier[unit1 .. 'menu'] = missionCommands.addSubMenuForCoalition(Wrench.Carrier[unit1 .. 'coa'],unit1 ,CarScript)
	Wrench.Carrier[unit1 .. 'infomenu'] = missionCommands.addSubMenuForCoalition(Wrench.Carrier[unit1 .. 'coa'],'Info' ,Wrench.Carrier[unit1 .. 'menu'])
	Wrench.Carrier[unit1 .. 'cntrlmnu'] = missionCommands.addSubMenuForCoalition(Wrench.Carrier[unit1 .. 'coa'],'Controls' ,Wrench.Carrier[unit1 .. 'menu'])
	--CALLS
	Wrench.carrier_at_ip(unit1)
	--Wrench.shipshore(unit1,3)
	Wrench.get_wind(unit1, 5000)
	mist.scheduleFunction(Wrench.get_wind, {unit1, distip}, timer.getTime() + 10, 10, timer.getTime() + 100000)
	local cargroup = Unit.getGroup(Wrench.Carrier[unit1]):getName()
	cargroup = Group.getByName(cargroup)
	mist.scheduleFunction(trigger.action.pushAITask,{cargroup, 1} ,timer.getTime() + 1 , 60 ,timer.getTime() + 100000)
	--add submenues
	local allgroups = mist.DBs.MEgroupsById
	if  Wrench.Carrier[unit1 .. 'coa'] == 1 then
		Wrench.Carrier[unit1 .. 'coastring'] = 'red'
	else
		 Wrench.Carrier[unit1 .. 'coastring'] = 'blue'
	end
	allgroups2 = {}
	for key,value in pairs(allgroups) do
		allgroups2[#allgroups2+1] = value
	end
		for i=1,#allgroups2 do
		if allgroups2[i] then
			if allgroups2[i]["units"][1]["coalition"] ==  Wrench.Carrier[unit1 .. 'coastring'] then
				missionCommands.addCommandForGroup(allgroups2[i]["groupId"],('Get BRC for ' .. unit1), Wrench.Carrier[unit1 .. 'infomenu'],function() trigger.action.outTextForGroup(allgroups2[i]["groupId"],'BRC for ' .. unit1 .. " is " .. Wrench.Carrier[unit1..'dir'].. '.', 10) end, nil)
				missionCommands.addCommandForGroup(allgroups2[i]["groupId"],(unit1 .. ' Automatic'), Wrench.Carrier[unit1 .. 'cntrlmnu'],function() Wrench.Carrier[unit1 .. 'override'] = false Wrench.Carrier[unit1 .. 'stop'] = false trigger.action.outTextForGroup(allgroups2[i]["groupId"],unit1 .. ' Automatic.', 2) end, nil)
				missionCommands.addCommandForGroup(allgroups2[i]["groupId"],(unit1 .. ' Override'), Wrench.Carrier[unit1 .. 'cntrlmnu'],function() Wrench.Carrier[unit1 .. 'override'] = true Wrench.Carrier[unit1 .. 'returning'] = false Wrench.Carrier[unit1 .. 'stop'] = false trigger.action.outTextForGroup(allgroups2[i]["groupId"],unit1 .. ' Override.', 2) end, nil)
				missionCommands.addCommandForGroup(allgroups2[i]["groupId"],(unit1 .. ' Stop'), Wrench.Carrier[unit1 .. 'cntrlmnu'],function() trigger.action.groupStopMoving(Wrench.Carrier[unit1 .. 'group']) Wrench.Carrier[unit1 .. 'stop'] = true trigger.action.outTextForGroup(allgroups2[i]["groupId"],unit1 .. ' Stopped.', 2) end, nil)
				missionCommands.addCommandForGroup(allgroups2[i]["groupId"],(unit1 .. ' Query'), Wrench.Carrier[unit1 .. 'infomenu'],function() Wrench.querymode(unit1,allgroups2[i]["groupId"]) end, nil)
				missionCommands.addCommandForGroup(allgroups2[i]["groupId"],('Get Bearing and Range to '..unit1), Wrench.Carrier[unit1 .. 'infomenu'],function() myLog:msg(allgroups2[i]["groupName"]) Wrench.get_carpos_BR(unit1,allgroups2[i]["groupName"]) end, nil)
				missionCommands.addCommandForGroup(allgroups2[i]["groupId"],('Get TACAN for '..unit1), Wrench.Carrier[unit1 .. 'infomenu'],function() 
					trigger.action.outTextForGroup(allgroups2[i]["groupId"], 
						tostring('TACAN for ' .. 
						tostring(Wrench.Carrier[unit1 .. 'name'] or 'N/A') .. 
						'\n    Channel: ' .. 
						tostring(Wrench.Carrier[unit1 .. 'tacan']["channel"] or 'N/A') .. 
						tostring(Wrench.Carrier[unit1 .. 'tacan']["modeChannel"] or '').. 
						'\n    Callsign: ' ..  
						tostring(Wrench.Carrier[unit1 .. 'tacan']["callsign"] or 'N/A')..
						'\nICLS: ' .. tostring(Wrench.Carrier[unit1 .. 'ICLS']["channel"] or 'N/A')), 
						30 , false) 
						end, nil)
				
				missionCommands.addCommandForGroup(allgroups2[i]["groupId"],('Tanker range + 0.5 '), Wrench.Carrier[unit1 .. 'cntrlmnu'],function() Wrench.Carrier.Tankerdist = Wrench.Carrier.Tankerdist+926 trigger.action.outText(Wrench.Carrier.Tankerdist/1852, 10 , false) end, nil)
				missionCommands.addCommandForGroup(allgroups2[i]["groupId"],('Tanker range - 0.5 '), Wrench.Carrier[unit1 .. 'cntrlmnu'],function() Wrench.Carrier.Tankerdist = Wrench.Carrier.Tankerdist-926 trigger.action.outText(Wrench.Carrier.Tankerdist/1852, 10 , false) end, nil)
			end
		end
		end
	--TANKER STUFF
	if tanker then
	Wrench.Carrier[unit1 .. 'tankmenu'] = missionCommands.addSubMenuForCoalition(Wrench.Carrier[unit1 .. 'coa'],'Tankers' , Wrench.Carrier[unit1 .. 'menu'])
	for i=1, #tanker do
		Wrench.Carrier[tanker[i] .. 'group'] = Unit.getByName(tanker[i]):getGroup()
		Wrench.Carrier[tanker[i] .. 'callsign'] = Unit.getByName(tanker[i]):getCallsign()
			if Unit.getByName(tanker[i]) then
			myLog:msg('Tanker Script by Wrench Called for '..tanker[i])
				------------get TACAN------------
				local route = mist.getGroupRoute(Wrench.Carrier[tanker[i] .. 'group']:getName() , true)
				local tasks = route[1]["task"]["params"]["tasks"]
				Wrench.Carrier[tanker[i] .. 'tacan'] = {}
				Wrench.Carrier[tanker[i] .. 'tacan']["callsign"] = {}
				for j=1,#tasks do
					if tasks[j]["params"]["action"] then
						if tasks[j]["params"]["action"]["id"] == "ActivateBeacon" then
						myLog:msg(tanker[i]..'tanker tacan added')
							Wrench.Carrier[tanker[i] .. 'tacan']["callsign"] = tasks[j]["params"]["action"]["params"]["callsign"]
							Wrench.Carrier[tanker[i] .. 'tacan']["modeChannel"] = tasks[j]["params"]["action"]["params"]["modeChannel"]
							Wrench.Carrier[tanker[i] .. 'tacan']["channel"] = tasks[j]["params"]["action"]["params"]["channel"]
						end
					end
				end
			
				mist.scheduleFunction(Wrench.orbit_carrier, {unit1, tanker[i],Wrench.Carrier[unit1..'dir']}, timer.getTime() + 5, 1, timer.getTime() + 6)
			end
		--------tanker commands--------
		Wrench.Carrier[tanker[i] .. 'menu'] = missionCommands.addSubMenuForCoalition(Wrench.Carrier[unit1 .. 'coa'],Wrench.Carrier[tanker[i] .. 'callsign'] , Wrench.Carrier[unit1 .. 'tankmenu'])
		missionCommands.addCommandForCoalition(Wrench.Carrier[unit1 .. 'coa'],('Spawn ' .. Wrench.Carrier[tanker[i] .. 'callsign']), Wrench.Carrier[tanker[i] .. 'menu'],function()
			spawntanker = mist.respawnGroup(Wrench.Carrier[tanker[i] .. 'group']:getName(),true)
			spawntanker = spawntanker["units"][1]["name"]
			mist.scheduleFunction(Wrench.orbit_carrier, {unit1, spawntanker,Wrench.Carrier[unit1..'dir']}, timer.getTime() + 5, 1, timer.getTime() + 6)
		end, nil)
		missionCommands.addCommandForCoalition(Wrench.Carrier[unit1 .. 'coa'],(Wrench.Carrier[tanker[i] .. 'callsign'] .. ' Check Fuel'), Wrench.Carrier[tanker[i] .. 'menu'],function() trigger.action.outText(Wrench.Carrier[tanker[i] .. 'callsign'].. ' has '..mist.utils.round((Unit.getFuel(Unit.getByName(tanker[i]))*17.225),1)..' thousand lbs of fuel.', 10) end, nil)
		missionCommands.addCommandForCoalition(Wrench.Carrier[unit1 .. 'coa'],('Get TACAN for '..Wrench.Carrier[tanker[i] .. 'callsign']), Wrench.Carrier[tanker[i] .. 'menu'],function() 
			trigger.action.outTextForCoalition(Wrench.Carrier[unit1 .. 'coa'], 
				tostring('TACAN for ' .. 
				tostring(Wrench.Carrier[tanker[i] .. 'callsign'] or 'N/A') .. 
				'\n    Channel: ' .. 
				tostring(Wrench.Carrier[tanker[i] .. 'tacan']["channel"] or 'N/A') .. 
				tostring(Wrench.Carrier[tanker[i] .. 'tacan']["modeChannel"] or '').. 
				'\n    Callsign: ' ..  
				tostring(Wrench.Carrier[tanker[i] .. 'tacan']["callsign"] or 'N/A')), 
				30 , false) 
			end, nil)
	end
	end

end
--[[CHANGELOG
Fixed boat speed caclulation
Added BRC to F10>Carrier Script
Added TACAN Bug fix
Removed 'dist' argument
Changed trigger system to dynamic variable system, so multiple carriers can be used.
Added Manual Override
Made menus Coalition Specific
Removed extraneous comments
Added stop menu option
Added Query Menu option
Added Time-Based Option
Added Tanker Script
Fixed Tanker stops tanking bug
Chnaged vectormath for tanker's route
Changed LARC to time be in Minutes
Changed tankers radio command to its callsign
Reduced tanker's altitude to 6000 (more realistic for carier ops.)
Added suport for multiple tankers
Adjust tanker's waypoints
made messages group specific.
Added more detail to Query reports.
Changed BRC calculation to use MAGVAR, thus it will work on all maps.
--1.1
Added carrier speed function. Will have the carrier slow down while turning.
Removed a bunch of pos1=carrier:getpos and made that global. "Wrench.Carrier[unit1..'position']"
moved tanker f10 to inside of carrier, as each carrier has it's own tankers
put all f10 in submenues.
fixed tanker fuel query
tanker fuel query now outputs x.x thousands.
Added get BR to carrier
Added Bulls and Cordinates for carrier
Added get TACAN for carrier (uses WP 0)
Added get TACAN for Tankers
1.1.1
Corrected Typos
corrected Carrier return behaviour
Carrier should now always make left-hand turns

]]--

